#import "FlutterBaiduImageclassifyPlugin.h"
#import <UIKit/UIKit.h>
#import "sdk/image_classify.h"

@implementation FlutterBaiduImageclassifyPlugin {
  NSDictionary *_arguments;
}

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    FlutterBaiduImageclassifyPlugin *instance = [FlutterBaiduImageclassifyPlugin new];
    FlutterMethodChannel *channel0 =
        [FlutterMethodChannel methodChannelWithName:@"flutter_baidu_imageclassify" binaryMessenger:[registrar messenger]];
    [registrar addMethodCallDelegate:instance channel:channel0];
    FlutterMethodChannel *channel1 =
        [FlutterMethodChannel methodChannelWithName:@"flutter_baidu_imageclassify_stream" binaryMessenger:[registrar messenger]];
    [registrar addMethodCallDelegate:instance channel:channel1];
}

-(void)handleMethodCall:(FlutterMethodCall *)call result:(FlutterResult)result {
  if ([@"classify" isEqualToString:call.method]) {
      _arguments = call.arguments;
      NSString* path = [_arguments objectForKey:@"path"];
      NSString* APP_ID = [_arguments objectForKey:@"APP_ID"];
      NSString* API_KEY = [_arguments objectForKey:@"API_KEY"];
      NSString* SECRET_KEY = [_arguments objectForKey:@"SECRET_KEY"];
      NSString* CONNECT_TIMEOUT = [_arguments objectForKey:@"CONNECT_TIMEOUT"];
      NSString* SOCKET_TIMEOUT = [_arguments objectForKey:@"SOCKET_TIMEOUT"];
      NSString* TOP_NUM = [_arguments objectForKey:@"TOP_NUM"];
      NSString* BAIKE_NUM = [_arguments objectForKey:@"BAIKE_NUM"];
      [self classify:path APP_ID:APP_ID API_KEY:API_KEY SECRET_KEY:SECRET_KEY CONNECT_TIMEOUT:CONNECT_TIMEOUT SOCKET_TIMEOUT:SOCKET_TIMEOUT TOP_NUM:TOP_NUM BAIKE_NUM:BAIKE_NUM result:result];
  }else if([@"getPlatformVersion" isEqualToString:call.method]){
      NSString* str =@"iOS ";
      str = [str stringByAppendingFormat:@"%@", [[UIDevice currentDevice] systemVersion]];
      result(str);
  } else {
    result(FlutterMethodNotImplemented);
  }
}

-(void)classify:(NSString*)path APP_ID:(NSString*)APP_ID API_KEY:(NSString*)API_KEY SECRET_KEY:(NSString*)SECRET_KEY CONNECT_TIMEOUT:(NSString*)CONNECT_TIMEOUT SOCKET_TIMEOUT:(NSString*)SOCKET_TIMEOUT TOP_NUM:(NSString*)TOP_NUM BAIKE_NUM:(NSString*)BAIKE_NUM result:(FlutterResult)result{
    NSLog(@"### 1: %@",path);
    std::string app_id = MakeStringCopy([APP_ID UTF8String]);
    std::string api_key = MakeStringCopy([API_KEY UTF8String]);
    std::string secret_key = MakeStringCopy([SECRET_KEY UTF8String]);
    aip::Imageclassify client(app_id,api_key,secret_key);
    client.setSocketTimeoutInMillis([SOCKET_TIMEOUT intValue]);
    client.setConnectionTimeoutInMillis([CONNECT_TIMEOUT intValue]);
    NSLog(@"### 2: %@",APP_ID);
    Json::Value jsonResult;
    std::string image;
    aip::get_file_content([path UTF8String], &image);
    std::map<std::string, std::string> options;
    options["top_num"] = MakeStringCopy([TOP_NUM UTF8String]);
    options["baike_num"] = MakeStringCopy([BAIKE_NUM UTF8String]);
    // 带参数调用动物识别
    jsonResult = client.animal_detect(image, options);
    std::string jsonStr;
    Json::StreamWriterBuilder writerBuilder;
    std::ostringstream os;
    std::unique_ptr<Json::StreamWriter> jsonWriter(writerBuilder.newStreamWriter());
    jsonWriter->write(jsonResult, &os);
    jsonStr = os.str();
    NSString *str = [[NSString alloc] initWithUTF8String:jsonStr.c_str()];
    NSLog(@"### 3: %@",str);
    result(str);
}

std::string MakeStringCopy (const char* string){
    std::string str;
    char res[5000]={0};
    strncpy(res, string,strlen(string)+1);
    str =  res;
    return str;
}
@end
