import 'dart:async';
import 'package:flutter/services.dart';

class FlutterBaiduImageclassify {
  static const MethodChannel _channel = const MethodChannel('flutter_baidu_imageclassify');
  static const EventChannel _stream = const EventChannel("flutter_baidu_imageclassify_stream");

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<String> classify(Map map) async {
    return await _channel.invokeMethod("classify", map);
  }

  /// 原生端回传键值对map到flutter端
  /// map中key为isInChina对应的value，如果为1则判断是在国内，为0则判断是在国外
  /// map中存在key为nearby则判断为已到达设置监听位置附近
  Stream<String> onResultCallback() {
    Stream<String> result;
    if (result == null) {
      result = _stream.receiveBroadcastStream().cast<String>();
    }
    return result;
  }
}
